Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
Botan::Cipher_Mode_Filter Class Reference

`#include <cipher_filter.h>`

Inheritance diagram for Botan::Cipher_Mode_Filter:

## Public Member Functions
virtual bool | attachable ()
| Cipher_Mode_Filter (Cipher_Mode *t)
Key_Length_Specification | key_spec () const override
std::string | name () const override
void | set_iv (const InitializationVector &iv) override
void | set_key (const SymmetricKey &key) override
bool | valid_iv_length (size_t length) const override
bool | valid_keylength (size_t length) const

## Protected Member Functions
const Cipher_Mode & | get_mode () const
Cipher_Mode & | get_mode ()
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Private Member Functions
void | buffer_reset ()
size_t | buffered_block_size () const
size_t | current_position () const
template<typename Alloc >
void | write (const std::vector< uint8_t, Alloc > &in, size_t length)

## Detailed Description

Filter interface for cipher modes

Definition at line 20 of file cipher_filter.h.

## Constructor & Destructor Documentation

Botan::Cipher_Mode_Filter::Cipher_Mode_Filter | ( | Cipher_Mode * | t | ) |
| explicit

Definition at line 27 of file cipher_filter.cpp.

27 :
28 Buffered_Filter(choose_update_size(mode->update_granularity()),
29 mode->minimum_final_size()),
30 m_nonce(mode->default_nonce_length() == 0),
31 m_mode(mode),
32 m_buffer(m_mode->update_granularity())
33 {
34 }
Botan::Buffered_Filter::Buffered_Filter
Buffered_Filter(size_t block_size, size_t final_minimum)
Definition: buf_filt.cpp:18

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

const Cipher_Mode& Botan::Cipher_Mode_Filter::get_mode | ( |  | ) | const
| inline protected

Definition at line 37 of file cipher_filter.h.

37 { return *m_mode; }

Cipher_Mode& Botan::Cipher_Mode_Filter::get_mode | ( |  | ) |
| inline protected

Definition at line 39 of file cipher_filter.h.

39 { return *m_mode; }

Key_Length_Specification Botan::Cipher_Mode_Filter::key_spec | ( |  | ) | const
| override virtual

Returns
  object describing limits on key size

Implements Botan::Keyed_Filter.

Definition at line 66 of file cipher_filter.cpp.

67 {
68 return m_mode->key_spec();
69 }

std::string Botan::Cipher_Mode_Filter::name | ( |  | ) | const
| override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 36 of file cipher_filter.cpp.

37 {
38 return m_mode->name();
39 }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Cipher_Mode_Filter::set_iv | ( | const InitializationVector & | iv | ) |
| override virtual

Set the initialization vector of this filter. Note: you should call set_iv() only after you have called set_key()

Parameters

  iv | the initialization vector to use

Reimplemented from Botan::Keyed_Filter.

Definition at line 56 of file cipher_filter.cpp.

57 {
58 m_nonce.update(iv);
59 }

void Botan::Cipher_Mode_Filter::set_key | ( | const SymmetricKey & | key | ) |
| override virtual

Set the key of this filter

Parameters

  key | the key to use

Implements Botan::Keyed_Filter.

Definition at line 61 of file cipher_filter.cpp.

62 {
63 m_mode->set_key(key);
64 }

bool Botan::Cipher_Mode_Filter::valid_iv_length | ( | size_t | length | ) | const
| override virtual

Check whether an IV length is valid for this filter

Parameters

  length | the IV length to be checked for validity

Returns
  true if the IV length is valid, false otherwise

Reimplemented from Botan::Keyed_Filter.

Definition at line 71 of file cipher_filter.cpp.

72 {
73 return m_mode->valid_nonce_length(length);
74 }

bool Botan::Keyed_Filter::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a key length is valid for this filter

Parameters

  length | the key length to be checked for validity

Returns
  true if the key length is valid, false otherwise

Definition at line 42 of file key_filt.h.

43 {
44 return key_spec().valid_keylength(length);
45 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Keyed_Filter::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/lib/filters/cipher_filter.h
- src/lib/filters/cipher_filter.cpp